// ExportTrackPointForContentAwareFill.jsx
// Copyright (c) 2011 Motion Boutique

function getContentAwareFillScriptTemplate()
{
	var str =
	"function openImageFile(file) \
	{ \
		var idOpn = charIDToTypeID( \"Opn \" ); \
		var desc78 = new ActionDescriptor(); \
		var idnull = charIDToTypeID( \"null\" ); \
		desc78.putPath( idnull, file ); \
		executeAction( idOpn, desc78, DialogModes.NO ); \
	} \
	function saveImageFile(file) \
	{ \
		var idsave = charIDToTypeID( \"save\" ); \
		var desc83 = new ActionDescriptor(); \
		var idAs = charIDToTypeID( \"As  \" ); \
		var desc84 = new ActionDescriptor(); \
		var idEQlt = charIDToTypeID( \"EQlt\" ); \
		desc84.putInteger( idEQlt, 8 ); \
		var idMttC = charIDToTypeID( \"MttC\" ); \
		var idMttC = charIDToTypeID( \"MttC\" ); \
		var idNone = charIDToTypeID( \"None\" ); \
		desc84.putEnumerated( idMttC, idMttC, idNone ); \
		var idJPEG = charIDToTypeID( \"JPEG\" ); \
		desc83.putObject( idAs, idJPEG, desc84 ); \
		var idIn = charIDToTypeID( \"In  \" ); \
		desc83.putPath( idIn, file ); \
		executeAction( idsave, desc83, DialogModes.NO ); \
	} \
	function contentAwareFill(top, left, bottom, right) \
	{ \
		var idslct = charIDToTypeID( \"slct\" ); \
		var desc147 = new ActionDescriptor(); \
		var idnull = charIDToTypeID( \"null\" ); \
		var ref49 = new ActionReference(); \
		var idmarqueeRectTool = stringIDToTypeID( \"marqueeRectTool\" ); \
		ref49.putClass( idmarqueeRectTool ); \
		desc147.putReference( idnull, ref49 ); \
		var iddontRecord = stringIDToTypeID( \"dontRecord\" ); \
		desc147.putBoolean( iddontRecord, true ); \
		var idforceNotify = stringIDToTypeID( \"forceNotify\" ); \
		desc147.putBoolean( idforceNotify, true ); \
		executeAction( idslct, desc147, DialogModes.NO ); \
		var idsetd = charIDToTypeID( \"setd\" ); \
		var desc148 = new ActionDescriptor(); \
		var idnull = charIDToTypeID( \"null\" ); \
		var ref50 = new ActionReference(); \
		var idChnl = charIDToTypeID( \"Chnl\" ); \
		var idfsel = charIDToTypeID( \"fsel\" ); \
		ref50.putProperty( idChnl, idfsel ); \
		desc148.putReference( idnull, ref50 ); \
		var idT = charIDToTypeID( \"T   \" ); \
		var desc149 = new ActionDescriptor(); \
		var idTop = charIDToTypeID( \"Top \" ); \
		var idPxl = charIDToTypeID( \"#Pxl\" ); \
		desc149.putUnitDouble( idTop, idPxl, top ); \
		var idLeft = charIDToTypeID( \"Left\" ); \
		var idPxl = charIDToTypeID( \"#Pxl\" ); \
		desc149.putUnitDouble( idLeft, idPxl, left ); \
		var idBtom = charIDToTypeID( \"Btom\" ); \
		var idPxl = charIDToTypeID( \"#Pxl\" ); \
		desc149.putUnitDouble( idBtom, idPxl, bottom ); \
		var idRght = charIDToTypeID( \"Rght\" ); \
		var idPxl = charIDToTypeID( \"#Pxl\" ); \
		desc149.putUnitDouble( idRght, idPxl, right ); \
		var idRctn = charIDToTypeID( \"Rctn\" ); \
		desc148.putObject( idT, idRctn, desc149 ); \
		executeAction( idsetd, desc148, DialogModes.NO ); \
		var idFl = charIDToTypeID( \"Fl  \" ); \
		var desc150 = new ActionDescriptor(); \
		var idUsng = charIDToTypeID( \"Usng\" ); \
		var idFlCn = charIDToTypeID( \"FlCn\" ); \
		var idcontentAware = stringIDToTypeID( \"contentAware\" ); \
		desc150.putEnumerated( idUsng, idFlCn, idcontentAware ); \
		var idOpct = charIDToTypeID( \"Opct\" ); \
		var idPrc = charIDToTypeID( \"#Prc\" ); \
		desc150.putUnitDouble( idOpct, idPrc, 100.000000 ); \
		var idMd = charIDToTypeID( \"Md  \" ); \
		var idBlnM = charIDToTypeID( \"BlnM\" ); \
		var idNrml = charIDToTypeID( \"Nrml\" ); \
		desc150.putEnumerated( idMd, idBlnM, idNrml ); \
		executeAction( idFl, desc150, DialogModes.NO ); \
	} \
	function closeCurrentFile() \
	{ \
		var idCls = charIDToTypeID( \"Cls \" ); \
		var desc143 = new ActionDescriptor(); \
		var idSvng = charIDToTypeID( \"Svng\" ); \
		var idYsN = charIDToTypeID( \"YsN \" ); \
		var idN = charIDToTypeID( \"N   \" ); \
		desc143.putEnumerated( idSvng, idYsN, idN ); \
		executeAction( idCls, desc143, DialogModes.NO ); \
	} \
	function run(imageFolderPath, corners) \
	{ \
		var fcounter = 0; \
		var files = Folder(imageFolderPath).getFiles(); \
		for (var i = 0; i < files.length; i++) \
		{ \
			if (files[i] instanceof File) \
			{ \
				if (files[i].name.toLowerCase().indexOf(\".png\") 	!= -1 	|| \
					files[i].name.toLowerCase().indexOf(\".tif\") 	!= -1 	|| \
					files[i].name.toLowerCase().indexOf(\".tiff\")	!= -1 	|| \
					files[i].name.toLowerCase().indexOf(\".tga\") 	!= -1 	|| \
					files[i].name.toLowerCase().indexOf(\".jpg\") 	!= -1 	|| \
					files[i].name.toLowerCase().indexOf(\".jpeg\")	!= -1) \
				{ \
					openImageFile( files[i] ); \
					contentAwareFill(corners[fcounter][0], corners[fcounter][1], corners[fcounter][2], corners[fcounter][3]); \
					var processedFolder = Folder(imageFolderPath + \"processed\"); \
					if (!processedFolder.exists) \
					{ \
						processedFolder.create(); \
					} \
					var processedFolderName = \"processed/\"; \
					saveImageFile(new File(imageFolderPath + processedFolderName + \"processed_\" + File.decode(files[i].name))); \
					closeCurrentFile(); \
					fcounter++; \
				} \
			} \
		} \
	}";	
	return str;
}

function run()
{
	var comp = app.project.activeItem;
	if (!(comp instanceof CompItem))
	{
		alert("Select a track point.");
		return;
	}
	
	var selProps = comp.selectedProperties;
	if (selProps.length != 1)
	{
		alert("Select a track point.");
		return;
	}
	var trackPoint = comp.selectedProperties[0];	
	if (trackPoint.matchName != "ADBE MTracker Pt")
	{
		alert("Select a track point.");
		return;
	}
	
	//var psScriptTemplate = //File("psContentAwareFillTemplate.jsx");
	var psScript = new File("psBatchContentAwareFill.jsx");
	
	if (/*psScriptTemplate.open("r") && */psScript.open("w"))
	{
		//var content = psScriptTemplate.read();
		//psScript.writeln(content);
		
		var str = getContentAwareFillScriptTemplate() + "\r" +
		"var imageFolderPath = \"" + imageFolderPath + "\"; \r" +
		"var corners = \r" +
		"[ \r";
		
		for (var i = 0; i < comp.duration - 0.01; i+=comp.frameDuration)
		{
			var featureSizeVal = trackPoint.property("ADBE MTracker Pt Feature Size").valueAtTime(i, false);
			var attachPtVal = trackPoint.property("ADBE MTracker Pt Attach Pt").valueAtTime(i, false);
	   		
	   		var t = attachPtVal[1] - (featureSizeVal[1]/2);
	   		var l = attachPtVal[0] - (featureSizeVal[0]/2);
	   		var b = attachPtVal[1] + (featureSizeVal[1]/2);
	   		var r = attachPtVal[0] + (featureSizeVal[0]/2);
	   		
	   		str += "[" + t.toFixed(6) + "," + l.toFixed(6) + "," + b.toFixed(6) + "," + r.toFixed(6) + "]";
	   		if (i < comp.duration + 0.01 - comp.frameDuration)
	   		{
				str += ",\r";
			}
		}
		str += "];\r";
		str += "run(imageFolderPath, corners);";
		
	             
	    // write value
	    psScript.write(str);
	    
	    //psScriptTemplate.close();
	    psScript.close();
	    
	    alert("'psBatchContentAwareFill.jsx' has been created successfully. Please execute it in Photoshop CS5 or later.");
	}
	else
	{
		alert("Can't open template script file.");
	}
}

var curFolder = Folder.current;
var imageFolder = curFolder.selectDlg("Select images folder to be processed:");
var imageFolderPath = imageFolder.fsName.replace(/\\/g,'/') + "/";
//alert(imageFolderPath);
run();
